/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: prc_support.S 1157 2008-06-26 03:10:08Z ertl-yutaka $
 */

/*
 *	ץå¸⥸塼 ֥M32Rѡ
 */

#define	TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */
		
#include "kernel_impl.h"
#include "m32rasm.inc"
#include "offset.h"
		
	.extern	reqflg
	.extern	p_runtsk
	.extern	p_schedtsk
	.extern	inh_tbl
	.extern	exch_tbl
	.extern	ext_tsk
	.extern dspflg
	.extern lock_flag
	.extern saved_iipm
		
/*
 *  EIT٥ȥ
 */
	.section ".vector","ax"
	.extern   start

	.balign 0x10
vector_entry_ri:
    /* 
	 *  ꥻåȳ(RI)
	 */
	bra		start

	.balign 0x10
vector_entry_sbi:
    /* 
	 *  ƥ֥졼(SBI)
	 */
	stmdb	"r0,r1"
	ldi		r1, #EXC_SBI
	bra		exception_handler

	.balign 0x10
vector_entry_rie:
    /* 
	 *  ͽ̿㳰Reserved Instruction Exception
	 */
	stmdb	"r0,r1"
	ldi		r1, #EXC_RIE
	bra		exception_handler

	.balign 0x10
vector_entry_ae:
    /* 
	 *  ɥ쥹㳰Address Exception
	 */
	stmdb	"r0,r1"
	ldi		r1, #EXC_AE
	bra		exception_handler

	.balign 0x10
vector_entry_trap:
    /*
	 *  ȥåץ٥ȥ
	 */
	bra		_trap_handler_0
	bra		_trap_handler_1
	bra		_trap_handler_2
	bra		_trap_handler_3
	bra		_trap_handler_4
	bra		_trap_handler_5
	bra		_trap_handler_6
	bra		_trap_handler_7
	bra		_trap_handler_8
	bra		_trap_handler_9
	bra		_trap_handler_10
	bra		_trap_handler_11
	bra		_trap_handler_12
	bra		_trap_handler_13
	bra		_trap_handler_14
	bra		_trap_handler_15

	.balign 0x10
vector_entry_ei:
	/*
	 *  (EI)
	 */
	bra		interrupt_handler
		
/*
 *  ߥ٥ȥȳߥϥɥ鵯ư
 *
 *  ȯΥϡɥư
 *
 *  psw쥸smiepmcӥåȤbsmbiebpmbcӥåȤ
 *  롥bpcˤϳȯpcͤ롥
 *
 *	bsm <- sm
 *  bie <- ie
 *  bpm <- pm
 *  bc <- c
 *  bpc <- ȯpc
 *
 *	psw쥸smiepmcӥåȤʲΤ褦˹롥
 *
 *	sm <- 0
 *  ie <- 0
 *  pm <- 0
 *  c <- 0
 *
 *쥸Ѥ
 *  r0-r1ʺΰ
 *  r0-r7r14acc(hi/lo)bpcpswICUISTSpswʳߥϥɥƽ
 *  
 *  ܤpswʳϡȯΥƥȤбå
 *  򤹤롥2ܤpswϡߥϥɥμ¹ľ뤿ˡ
 *  ɬߥå򤹤롥ٱǥѥåˤϡ嵭
 *  쥸ʳˤ⡤r8-r13򤷤ƥǥѥåƤӽФ
 */
	.text
interrupt_handler:

	/* 
	 *  ѥ쥸 
	 *
	 *  ǽ˺ѥ쥸򥹥å򤹤롥ȯľϡɬ
	 *  ߥåˤʤΤǡ򤹤ѥ쥸ϳ
	 *  ߥåѤޤ롥
	 */
	stmdb	"r0,r1"

	/* 
	 *  ȯΥƥȽ
	 *
	 *  pswbsmӥåȤȯ˻ѤƤå
	 *  롥bsm0ξϡߥåѤƤȤˤʤ
	 *  ǡߥƥȤǳߤȯȽǤ롥bsm1ξ
	 *  ϡ桼åѤƤȤˤʤΤǡ
	 *  ȤǳߤȯȽǤ롥Ԥξϡΰr0
	 *  r1ˤѤľɬפʤ
	 */
	mvfc	r0, psw
	and3	r1, r0, #0x8000
	beqz	r1, L1

	/* 
	 *  쥸Υ桼åؤѤľ  
	 *
	 *  ƥȤǳߤȯϡߥå
	 *  򤷤ѥ쥸r0r1桼åѤľɬפ롥
	 */
	or3		r0, r0, #0x0080		
	mvtc	r0, psw				/* 桼åءsp = spu */
	mvfc	r1, spi
	ld		r0, @(4, r1)		/* 򤷤r0ߥåФ */
	st		r0, @-sp			/* r0桼åѤ */
	ld		r0, @r1				/* 򤷤r1ߥåФ */
	st		r0, @-sp			/* r1桼åѤ */
	addi	r1, #8				/* ߥåȥå᤹ */
	mvtc	r1, spi				/* ߥå֤spi¸ */
	mvfc	r0, psw

L1:
	/* 
	 *  ƥȤ
	 * 
	 *  r2-r7, r14, acch, accl, bpc, psw, ߥޥICUISTS,psw 
	 *  ν˥å򤹤롥ǤϡȯΥå
	 *  pswr0˳ǼƤ롥
	 */
	stmdb	"r2,r3,r4,r5,r6,r7,r14"

	mvfachi	r1
	st		r1, @-sp			/* acch */
	mvfaclo	r1
	st		r1, @-sp			/* accl */
	mvfc	r1, bpc
	st		r1, @-sp			/* bpc */
	st 		r0, @-sp			/* psw */

	ld24	r1, ICUISTS
	ld		r0, @r1				/* ߥơ쥸ɹߡȯ
								   ߤͥ٤ICUIMASK˥
								   ԡ졤EI׵ϥꥢ
								   
							   */
	st		r0, @-sp			/* ȯγͥ٥ޥ
								    */
	lea		r1, inh_tbl			/* ߥϥɥơ֥Ƭɥ쥹Ф */
	srli	r0, 20				/* ߥϥɥơ֥ΥեåȤ׻ */
	and3	r0, r0, #0xff
	add		r1, r0				/* ߥϥɥơ֥γߥ
								   ɥΥɥ쥹׻ */
	ld		r1, @r1				/* ߥϥɥεưϤФ */

	/*
	 *  ߥϥɥθƽФ
	 *
	 *  psw򤷡ߥå, ߥå֤ǳߥϥ
	 *  ɥƤӽФߥϥɥ餫Ϥret_intȤ롥
	 *  pswߥå򤹤Τϡret_intκǽǡEIT
	 *  ȯΥå᤹Τȡbpsw뤿Ǥ롥
	 */
	mvfc	r2, psw						/* ߥåߥå */
	and3	r2, r2, #0xff7f				/* ߥå */
	or3		r2, r2, #0x0040				/* ߥå */
	mvtc	r2, psw						
#ifdef LOG_INH_ENTER
	/* λr0ˤϳߥϥɥơ֥ΥեåȤäƤ */
	srli	r0, 2						/* եåȤֹѴ */
#ifdef LOG_INH_LEAVE
	st		r0, @-sp					/* ߥϥɥֹ */
#endif /* LOG_INH_LEAVE */
	st		r1, @-sp					/* ߥϥɥΥɥ쥹 */
	lea		r2, log_inh_enter
	jl		r2
	ld		r1, @sp+					/* ߥϥɥΥɥ쥹 */
#endif /* LOG_INH_ENTER */
	lea		r14, ret_int 				/* Ϥ */
	jmp		r1							/* ߥϥɥ鵯ư */

	.text
ret_int:
	/*
	 *  EITϥɥζ
	 *
	 *  EITʳߡ㳰ȥåס˥ϥɥμ¹ԤλȸƤӽ
	 *  롥ߥåߵľ֤äƤ롥EITȯ
	 *  Υƥȡ׵̵ͭǥѥåġػ߾֤
	 *  Ŭڤʬ롥
	 */
#ifdef LOG_INH_LEAVE
	ld		r0, @sp+			/* ߥϥɥֹ */
	lea		r1, log_inh_leave
	jl		r1
#endif /* LOG_INH_LEAVE */
	mvfc	r0, psw
	and3	r0, r0, #0x8000
	beqz	r0, ret_int_2	/* EITȯΥƥȤߥƥ
							   ȤǤС¿ųߤǤȽǤ
							   ¨¤˶ */
	mvfc	r0, psw
	and3	r0, r0, #0xffbf			/* ߥå */
	mvtc	r0, psw		
	ld24	r2, ICUIMASK+1			/* ͥߤػ */
	ldi		r1, #IIPM_LOCK				
	stb		r1, @r2
	or3		r0, r0, #0x00c0			/* 桼åߥå */
	mvtc	r0, psw		
		
	/* 
	 *  ƥȤؤ롼
	 *
	 *  ǥѥå㳰ư׵᤬ʤϡ¨¤˶롼
	 *  ֡
	 */
	lea		r0, reqflg
	ld		r1, @r0
	beqz	r1, ret_int_2
		
	/* 
	 *  ǥѥå㳰ư׵᤬ν
	 *
	 *  ǥѥå׵ե饰reqflgˤ򥯥ꥢ롥
	 */
	ldi		r1, #false					/* reqflg򥯥ꥢ */
	st		r1, @r0				

	/*
	 *  CPUå֤˰ܹ
	 *
	 *  ͥγߤϤǤ˶ػߤƤΤǡlock_flag
	 *  saved_iipm 򹹿롥saved_iipmϡγͥ٥ޥ
	 *  ʤɽˤꤹ롥
	 *
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 */
	lea		r1, lock_flag				/* CPUåե饰true */
	ldi		r0, #true
	st		r0, @r1
	lea		r1, saved_iipm				/* saved_iipm˳ȯ
										   ͥ٤ */
	ld 		r2, @sp						/* γͥ٥ޥ
										   롥ret_int_1Ǻ
										   ټФᡤǤϥ
										   åѹʤ
										    */
	srli	r2, #16 					
	and3	r2, r2, #0x0007				/* ͥ٤Ф */
	stb		r2, @r1		

	/*
	 *  ٱǥѥåȥ㳰ư
	 *
	 *  ǥѥåĥե饰dspflgˤFALSEξȡp_runtsk
	 *  p_schedtskƱˤϡǥѥå˥㳰ư
	 *  롼֡ǥѥåĤƤꡤp_runtsk
	 *  p_schedtskۤʤˤϡٱǥѥåԤ
	 */
	lea 	r0, dspflg					/* dspflgFALSEʤ饿㳰
										   ư */
	ld 		r0, @r0
	beqz 	r0, ret_int_3 				
	lea		r0, p_runtsk				/* p_runtskp_schedtskƱ
										   ϥ㳰ư
										    */
	ld		r0, @r0	
	lea		r1, p_schedtsk
    ld		r1, @r1
	beq		r0, r1, ret_int_3			

	/*
	 *  ٱǥѥå
	 *
	 *  򤷤ƤʤĤΥ쥸򤷡¹Ծ֥pcsp
	 *  򤷤ƤǥѥåƤӽФ
	 */
	stmdb	"r8,r9,r10,r11,r12,r13"

	lea		r0, p_runtsk
	ld		r0, @r0
	lea		r1, ret_int_r
	st		r1, @(TCB_pc, r0)
	st		sp, @(TCB_sp, r0)
	bra		dispatcher

ret_int_r:
	/*
	 *  ٱǥѥåνи
	 */
	ldmia	"r13,r12,r11,r10,r9,r8"

ret_int_3:
	/* 
	 *  㳰ư
	 *
	 *  ǡenatextrueǡtexptn0ǤʤС㳰롼
	 *  ƤӽФcalltexνơp_runtsk->enatextrueǡ
	 *  p_runtsk->texptn0Ǥʤˡcall_texrtnƤ֡ˤ򤳤˥
	 *  饤ŸΨɤδʰײΤcalltex 
	 *  ƤӽФ
	 */
	bl		calltex
				
ret_int_2:
	/* 
	 *  EIT¿ų߻ͥٳߤؤޤ
	 *
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
	 *  롥lock_flagFALSEˤΤϡCPUå֤Τޤ޳
	 *  ߥϥɥ餫äк
	 *
	 *  򤷤֡r2-r7, r14, acch, accl, bpc, pswˤεսǥ
	 *  Ф롥ޤѥ쥸r0r1ˤ
	 *  롥ǤϡŪ˳ߥå֤ˤƤEITȯe
	 *  ͥ٥ޥ롥Ǹrte̿ǳߥå	
	 *  ưŪCPUå֤ˤʤ롥
	 */
    lea		r1, lock_flag				/* CPUåե饰򥯥ꥢ */
	ldi		r0, #false
	st		r0, @r1
	bra		ret_int_1					/* EIT */

		
/*
 *  㳰ȥåץϥɥ
 *
 *  㳰ȯˤϡå쥸򤷤㳰װr1
 *  äƤˤб㳰ϥɥƤӽФ㳰ϥɥ餫
 *  ϡߥϥɥ餫ȶ̡ret_excˤǤ롥
 *
 *  㳰ȯΥϡɥư
 *
 *  psw쥸smiepmcӥåȤbsmbiebpmbcӥåȤ
 *  롥bpcˤ㳰򵯤̿pcͤ롥
 *
 *	bsm <- sm
 *  bie <- ie
 *  bpm <- pm
 *  bc <- c
 *  bpc <- 㳰򵯤̿Υɥ쥹
 *
 *	psw쥸smiepmcӥåȤʲΤ褦˹롥
 *
 *	sm <- 
 *  ie <- 0
 *  pm <- 0
 *  c <- 0
 *
 *  쥸Ѥ
 *
 *  r0-r1ʺΰ衤٥κǽ
 *  r2-r7r14acc(hi/lo)bpcpswICUIMASK㳰ϥɥƽ
 *
 *  ǡICUISTSǤϤʤICUIMASK򤹤Τϡ㳰˳
 *  ߤȯˡICUISTSɹߤˤװꥢ
 *  ƤޤΤɤǤ롥r1ˤ㳰װֹ椬ǼƤ롥
 */

/*
 *  ȥåפΥȥ : ȥåֹγǼ
 */
		
.irp num,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
.align	4

_trap_handler_\num:
	stmdb	"r0,r1"
	ldi		r1, #(\num + EXC_TRAP00)
	bra		exception_handler
.endr
		
exception_handler:

	stmdb 	"r2,r3,r4,r5,r6,r7,r14"
	mvfachi r0
	st 		r0, @-sp
	mvfaclo r0
	st 		r0, @-sp
	mvfc 	r0, bpc
	st 		r0, @-sp
	mvfc 	r2, psw
	st 		r2, @-sp				/* 򤷤psw
								   exc_sense_contextǻѤ롥 */

	ld24 	r0, ICUIMASK
	ld 		r2, @r0
	st 		r2, @-sp

	mv 		r3, sp

	lea		r0, lock_flag			/* CPUåե饰 */
	ld		r2, @r0
	st		r2, @-sp
		
	lea		r0, saved_iipm			/* ʥǥΡ˳ͥ٥ޥ */
	ld		r2, @r0
	st		r2, @-sp

	lea		r0, exch_tbl
	slli	r1, #2					/* 㳰װֹ椫饪եåȤ׻ */
	add		r0, r1
	ld		r4, @r0					/* 㳰ϥɥΥɥ쥹 */
	mv 		r0, r3					/* ͥ٤򤷤ǤΥ
								   ΰ֤㳰ϥɥΰ
								   p_excinfˤ */
	mvfc 	r2, psw 			
	and3 	r2, r2, #0xff7f			/* ߥå */
	or3		r2, r2, #0x0040			/* ߥå */
	mvtc 	r2, psw 			
#ifdef LOG_EXC_ENTER
	/* λr1ˤ㳰ϥɥơ֥ΥեåȤäƤ */
	srli	r1, 2					/* եåȤֹѴ */
#ifdef LOG_EXC_LEAVE
	st		r1, @-sp				/* 㳰ϥɥֹ */
#endif /* LOG_EXC_LEAVE */
	st		r0, @-sp				/* 㳰ϥɥΰ */
	mv		r0, r1					/* 㳰ϥɥֹ */
	st		r4, @-sp				/* 㳰ϥɥΥɥ쥹 */
	lea		r2, log_exc_enter
	jl		r2
	ld		r4, @sp+				/* 㳰ϥɥΥɥ쥹 */
	ld		r0, @sp+				/* 㳰ϥɥΰ */	
#endif /* LOG_EXC_ENTER */
	lea 	r14, ret_exc
	jmp 	r4

ret_exc:		
	/*
	 *  㳰ϥɥ
	 *
	 *  㳰ϥɥμ¹ԤλȸƤӽФ롥ߥå
	 *  ߵľ֤äƤ롥㳰ȯΥƥȡǥѥ
	 *  ׵̵ͭǥѥåġػ߾֤Ŭڤʬ
	 *  롥
	 */
#ifdef LOG_EXC_LEAVE
	ld		r0, @sp+					/* 㳰ϥɥֹ */
	lea		r1, log_exc_leave
	jl		r1
#endif /* LOG_EXC_LEAVE */

	mvfc	r0, psw
	and3	r0, r0, #0x8000
	beqz	r0, ret_exc_2	/* 㳰ȯΥƥȤߥ
							   ȤǤС¨¤˶ */

	mvfc	r0, psw
	and3	r0, r0, #0xffbf			/* ߥå */
	mvtc	r0, psw		
		
	ld24	r2, ICUIMASK+1			/* ͥߤػ */
	ldi		r1, #IIPM_LOCK				
	stb		r1, @r2

	or3		r0, r0, #0x00c0			/* ߥå */
	mvtc	r0, psw		
		
	/* 
	 *  ƥȤؤ롼
	 *
	 *  ǥѥå㳰ư׵᤬ʤϡ¨¤˶롼
	 *  ֡
	 */
	lea		r0, reqflg
	ld		r1, @r0
	beqz	r1, ret_exc_2
		
	/* 
	 *  ǥѥå㳰ư׵᤬ν
	 *
	 *  ǥѥå׵ե饰reqflgˤ򥯥ꥢ롥
	 */
	ldi		r1, #false					/* reqflg򥯥ꥢ */
	st		r1, @r0				

	/*
	 *  CPUå֤˰ܹ
	 *
	 *  ͥγߤϤǤ˶ػߤƤΤǡlock_flag
	 *  saved_iipm 򹹿롥saved_iipmϡγͥ٥ޥ
	 *  ʤɽˤꤹ롥
	 *
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 */
	lea		r1, lock_flag				/* CPUåե饰true */
	ldi		r0, #true
	st		r0, @r1

	lea		r1, saved_iipm				/* saved_iipm˳ȯ
										   ͥ٤ */
		
	mv 		r0, sp						/* γͥ٥ޥ
										   롥lock_flag
										   saved_iipmʬåͤ
										   롥*/

	addi	r0, #8							
	ld		r2, @r0									   
										  
	srli	r2, #16 					
	and3	r2, r2, #0x0007				/* ͥ٤Ф */
	stb		r2, @r1		

	/*
	 *  ٱǥѥåȥ㳰ư
	 *
	 *  ǥѥåĥե饰dspflgˤfalseξȡp_runtsk
	 *  p_schedtskƱˤϡǥѥå˥㳰ư
	 *  롼֡ǥѥåĤƤꡤp_runtsk
	 *  p_schedtskۤʤˤϡٱǥѥåԤ
	 */
	lea 	r0, dspflg					/* dspflgfalseʤ饿㳰
										   ư */
	ld 		r0, @r0
	beqz 	r0, ret_exc_3

	lea		r0, p_runtsk				/* p_runtskp_schedtskƱ
										   ϥ㳰ư
										    */
	lea		r1, p_schedtsk
	ld		r0, @r0	
    ld		r1, @r1
	beq		r0, r1, ret_exc_3

	/*
	 *  ٱǥѥå
	 *
	 *  򤷤ƤʤĤΥ쥸򤷡¹Ծ֥pcsp
	 *  򤷤ƤǥѥåƤӽФ
	 */
	stmdb	"r8,r9,r10,r11,r12,r13"

	lea		r0, p_runtsk
	ld		r0, @r0

	lea		r1, ret_exc_r
	st		r1, @(TCB_pc, r0)
	st		sp, @(TCB_sp, r0)
	bra		dispatcher

ret_exc_r:
	/*
	 *  ٱǥѥåνи
	 */
	ldmia	"r13,r12,r11,r10,r9,r8"

ret_exc_3:
	/* 
	 *  㳰ư
	 *
	 *  ǡenatextrueǡtexptn0ǤʤС㳰롼
	 *  ƤӽФcalltexνơp_runtsk->enatextrueǡ
	 *  p_runtsk->texptn0Ǥʤˡcall_texrtnƤ֡ˤ򤳤˥
	 *  饤ŸΨɤδʰײΤcalltex 
	 *  ƤӽФ
	 */
	bl		calltex
				
ret_exc_2:
	/* 
	 *  㳰
	 *
	 *  㳰Υ꥿ˤꡤ㳰ȯCPUå֤˰ܹ
	 *  褦롥
	 */
	lea		r0, saved_iipm		/* ʥǥΡ˳ͥ٥ޥ */
	ld		r1, @sp+
	st		r1, @r0

	lea		r0, lock_flag		/* CPUåե饰 */
	ld		r1, @sp+
	st		r1, @r0


ret_int_1:
ret_exc_1:

	/* 
	 *  EIT¿ų߻ͥٳߤؤޤ
	 *
	 *  򤷤֡r2-r7, r14, acch, accl, bpc, pswˤεսǥ
	 *  Ф롥ޤѥ쥸r0r1ˤ
	 *  롥ǤϡŪ˳ߥå֤ˤƤEITȯe
	 *  ͥ٥ޥ롥Ǹrte̿ǳߥå	
	 *  ưŪCPUå֤ˤʤ롥
	 */		
	ld 		r2, @sp+					/* EITȯγͥ٥ޥ
										   μ */
	ld 		r0, @sp+					/* EITȯΥå
										   å֤psw */
	mvtc 	r0, psw						

	ld24	r1, ICUIMASK				/* ͥ٥ޥ */
	st		r2, @r1						

	ld		r0, @sp+					/* bpc */
	mvtc	r0, bpc						
	ld		r0, @sp+					/* accl */
	mvtaclo	r0							
	ld		r0, @sp+					/* acch */
	mvtachi	r0							

	ldmia	"r14,r7,r6,r5,r4,r3,r2"		/* ¾Υ쥸 */
	ldmia	"r1,r0"						/* ѥ쥸 */
	rte									/* ȯν */
								
/*
 *  ǥѥå
 */
	.text
	.globl dispatch
dispatch:
	/*
	 *  ؤΤΥƥ
	 *
	 *  Υ롼ϡƥȡCPUå֡ǥѥ
	 *  ľ֤ǸƤӽФ롥ƽиǤ¸ʤ쥸򥹥
	 *  򤷡pcspTCB򤹤롥pcϥǥѥåи
	 *  dispatch_rˤꤹ롥
	 */
	stmdb	"r14"
	stmdb	"r8,r9,r10,r11,r12,r13"

	lea 	r0, p_runtsk
	ld		r0, @r0
	lea		r1, dispatch_r
	st		r1, @(TCB_pc, r0)			/* dispatch_r¹ԺƳϤ
										    */
	st		sp, @(TCB_sp, r0)			/* åݥ󥿤 */
	bra		dispatcher

dispatch_r:
	/* 
	 *  ǥѥåνи
	 * 
	 *  dispatch򤷤쥸㳰롼
	 *  ӽФ
	 */
	ldmia 	"r13,r12,r11,r10,r9,r8" 
	bl 		calltex 
	ldmia 	"r14"
	jmp		r14

/*
 *  ǥѥåưϡprc_support.S
 */
	.globl	start_dispatch		
start_dispatch:	
	/*
	 *  ͥ뵯ưΥǥѥå
	 *
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
     *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *  
	 *  prc_initializelock_flagtrueˡsaved_iipmIIPM_ENAALL˽
	 *  Ƥ뤿ᡤǤϥͥγߤĤ뤳
	 *  ǡCPUå֡ʥǥΡ˳ͥ٥ޥ
	 *  ˤʤ롥
	 */
	ldi		r0, #0x00c0			/* åߥå */
	mvtc	r0, psw
	bra		dispatcher_0

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
	 .globl exit_and_dispatch
exit_and_dispatch:

/*
 *  ǥѥå
 */
dispatcher:
#ifdef LOG_DSP_ENTER
	lea		r1, p_runtsk
	ld		r0, @r1
	lea		r1, log_dsp_enter
	jl		r1
#endif /* LOG_DSP_ENTER */
dispatcher_0:			
	/*
	 *  ؤ
	 *
	 *  Υ롼ϡƥȡCPUå֡ǥѥ
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽ
	 *  롥
	 *
	 *  schedtskǤʤå롥schedtskǤʤϡ
	 *  ؤ˰ܤ롥ξϡԤ򤹤뤿
	 *  dispatcher_1˰ܤ롥
	 */	
	lea		r1, p_schedtsk				/* p_schedtsk => p_runtsk */
	ld		r0, @r1
	lea		r2, p_runtsk				
	st		r0, @r2 					
	beqz	r0, dispatcher_1			/* p_runtskNULLʤdispatcher_1 */
		
	/* 
	 *  ؤ
	 *
	 *  p_runtskTCBsppc롥
	 */
	ld		sp, @(TCB_sp, r0)			/* åݥ󥿤 */
#ifdef LOG_DSP_LEAVE
	mv		r8, r0						/* r0 */
	lea		r1, log_dsp_leave
	jl		r1
	mv		r0, r8						/* r0 */
#endif /* LOG_DSP_LEAVE */		
	ld		r1, @(TCB_pc, r0)			/* ץ५󥿤 */
	jmp		r1			

dispatcher_1:	
	/*
	 *  CPUå򤹤롥
	 */
	lea		r2, lock_flag				/* CPUå */
	ldi		r1, #false
	st		r1, @r2

	ldi		r2, #0x0000					/* ߥåߥå */
    mvtc	r2, psw						
		
	ld24	r2, ICUIMASK+1				/* Ƥγߤ */ 
	ldi		r1, #IIPM_ENAALL
    stb		r1, @r2
				
dispatcher_2:
	/*
	 *  ߤĤߥ⡼ɤڤ괹ơߤԤġ
	 *
	 *  ǳߥ⡼ɤڤ괹Τϡȯ߽
	 *  ɤΥåȤȤβȡߥϥɥǤΥ
	 *  ǥѥåɻߤȤ2Ĥΰ̣롥
	 */
	ldi		r1, #0x0040				/* ߥåߥå */    
	mvtc	r1, psw						

	/* ǳߤդ */

	ldi		r1, #0x0000					/* ߥåߥå */
	mvtc	r1, psw						

	lea 	r2, reqflg					/* reqflgfalseʤdispatcher_2 */
	ld 		r1, @r2
	beqz	r1, dispatcher_2

	ldi		r0, #false					/* reqflgfalse */
	st 		r0, @r2 					

	/*
	 *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥ
	 *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤ
	 *  ɬפ롥dispatcher¹Ԥϡsaved_iipm
	 *  IIPM_ENAALL ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALL
	 *  ʡ0ˤ᤻Ф褤
	 */	
	ld24	r2, ICUIMASK+1				/* CPUå֤ */ 
	ldi		r1, #IIPM_LOCK
    stb		r1, @r2

	lea		r2, lock_flag				/* lock_flagtrue */
	ldi		r0, #true
	st		r0, @r2
		
	lea		r2, saved_iipm				/* saved_iipmIIPM_ENAALL */
	ldi		r0, #IIPM_ENAALL				
	stb		r0, @r2						

	ldi		r0, #0x00c0					/* 桼åߥå */
	mvtc	r0, psw				
						
	bra 	dispatcher
	
/*
 *  ϻ
 */
	.text
	.globl	start_r
start_r:
	/*
	 *  εư롼
	 *
	 *  runtskΥ֥å饿ؿȳĥФ
	 *  ơĥ쥸r0ˤꤹ롥ext_tskƤӽФ
	 *  ˥λ礬뤿ᡤؿϤ
	 *  ext_tskꤹ롥ؿ˥פˡCPUå
	 *  롥
	 */
	ldi		r1, #0x0080					/* 桼åߥå */    
	mvtc	r1, psw						
	
	lea		r2, lock_flag				/* CPUå */
	ldi		r1, #false
	st		r1, @r2
		
	ld24	r1, ICUIMASK+1				/* ߥޥIIPM_ENAALL */
	ldi		r0, #IIPM_ENAALL			
    stb		r0, @r1						

	ldi		r1, #0x00c0					/* 桼åߥå */    
	mvtc	r1, psw						
						
	lea		r2, p_runtsk
	ld		r2, @r2
	ld		r2, @(TCB_p_tinib, r2)		/* r2 = runtsk->tinib */
	ld		r0, @(TINIB_exinf, r2)
	lea		r14, ext_tsk				/* Ϥext_tsk */
	ld		r1, @(TINIB_task,  r2)

	jmp		r1							/* ؿ */


/*
 *  ͥνλθƽФ
 */		
	.globl	call_exit_kernel
call_exit_kernel:		
	ldi 	r0, #0x00					/* ߥåؤ */
	mvtc 	r0, psw 					
		
	lea		r2, lock_flag				/* CPUå֤ */
	ldi		r0, true
	st		r0, @r2

	ld24	r1, ICUIMASK+1
	ldi		r0, #IIPM_LOCK
	stb		r0, @r1						

	bra 	exit_kernel

/*
 *  ԤSILΥåȰ¸
 */
	.globl _sil_dly_nse
	.align 4
_sil_dly_nse:
//	addi	r0, #-SIL_DLY_TIM1		/* r0SIL_DLY_TIM1 */
	ldi		r1, #SIL_DLY_TIM1		/* r0SIL_DLY_TIM1 */
	sub		r0, r1
	bgtz	r0, _sil_dly_nse_1		/* ̤0ʲǤХ꥿ */
	jmp		r14
_sil_dly_nse_1:
//	addi	r0, #-SIL_DLY_TIM2		/* r0SIL_DLY_TIM2 */
	ldi		r1, #SIL_DLY_TIM2		/* r0SIL_DLY_TIM2 */
	sub		r0, r1
	bgtz	r0, _sil_dly_nse_1		/* ̤0ʲǤХ꥿ */
	jmp		r14
