/*
 *  @(#) $Id: m3aza36elf.ld 1154 2008-06-26 02:45:42Z ertl-yutaka $
 */

OUTPUT_FORMAT("elf32-m32r","elf32-m32r","elf32-m32r")
OUTPUT_ARCH(m32r)
STARTUP(start.o)

PROVIDE(hardware_init_hook = 0);
PROVIDE(software_init_hook = 0);
PROVIDE(software_term_hook = 0);

MEMORY
{
	IRAM(waxi)	: org = 0x00f00000, len = 32k		/* ¡RAMΰ 32kB	*/
	ERAM(waxi)	: org = 0x04000000, len = 64m		/* RAMΰ 64MB	*/
}

SECTIONS
{
    .text :	
    {
		__vector_start = .;
        *(.vector)
		. = ALIGN(4);
        *(.text)
    } > ERAM

	. = ALIGN(4);
    .rodata : 
	{
		. = ALIGN(4);
		 *(.rodata)
	} > ERAM

	. = ALIGN(4);
	__sidata = . ;
    .data   :  AT(__sidata) 
    {
		. = ALIGN(4);
		__sdata = .;
        *(.data)
		__edata = .;
    } > ERAM

	__eidata = __edata - __sdata + __sidata;

    .bss :
    {
		. = ALIGN(4);
		__sbss = .;
		*(.bss)
		*(COMMON)
		. = ALIGN(4);
		__ebss = .;
    } > ERAM

    .comment 		0 : { *(.comment) }	
    .debug          0 : { *(.debug) }
    .line           0 : { *(.line) }
    .debug_srcinfo  0 : { *(.debug_srcinfo) }
    .debug_sfnames  0 : { *(.debug_sfnames) }
    .debug_aranges  0 : { *(.debug_aranges) }
    .debug_pubnames 0 : { *(.debug_pubnames) }	
}
